



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【洛谷P1972】HH的项链 离线+树状数组</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【洛谷P1972】HH的项链 离线+树状数组</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 00:20:48 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题目大意：静态查询序列区间颜色数。</p>
<p>题解：对于一个查询区间 [l , r] ，若有两个相同颜色的点在这个区间中，则总是取下标靠近端点 r 的颜色计入答案贡献。对于每个下标，记录下在这个下标之前，且距离当前下标最近的，且与这个下标对应的颜色相同的下标是多少，即：\(min\{j,j&lt;i\&amp;\&amp;cor[j]=cor[i] \}\)。由于每个序列右端点结束后即可统计答案，因此对所有询问的右端点进行从小到大排序，并从左到右扫一遍序列，用树状数组维护当前序列中对 [1 , idx] 颜色有贡献的点的下标，每次扫描到一个点 idx 时，根据最开始提到的操作，用这个点的颜色替换离这个点最近的相同颜色的点，最后统计答案即可。可知在扫描的过程中 i 和 j 一共迭代了 n+m 次，因此时间复杂度为 \(O((n+m)logn)\)。</p>
<p>代码如下</p>
<pre class="prettyprint linenums"><code>#include &lt;bits/stdc++.h&gt;<br />
using namespace std;<br />
const int maxn=5e5+10;

inline int read(){<br />
	int x=0,f=1;char ch;<br />
	do{ch=getchar();if(ch=='-')f=-1;}while(!isdigit(ch));<br />
	do{x=x*10+ch-'0';ch=getchar();}while(isdigit(ch));<br />
	return f*x;<br />
}

int n,m,pre[maxn],h[maxn&lt;&lt;1],t[maxn],ans[maxn];<br />
struct rec{int l,r,id;}q[maxn];<br />
bool cmp(const rec &amp;x,const rec &amp;y){return x.r&lt;y.r;}<br />
inline int lowbit(int x){return x&amp;-x;}<br />
void modify(int pos,int val){<br />
	if(!pos)return;<br />
	for(int i=pos;i&lt;=n;i+=lowbit(i))t[i]+=val;<br />
}<br />
int query(int pos){<br />
	int res=0;<br />
	for(int i=pos;i;i-=lowbit(i))res+=t[i];<br />
	return res;<br />
}

void read_and_parse(){<br />
	n=read();<br />
	for(int i=1,x;i&lt;=n;i++){<br />
		x=read();<br />
		pre[i]=h[x],h[x]=i;<br />
	}<br />
	m=read();<br />
	for(int i=1;i&lt;=m;i++)q[i].l=read(),q[i].r=read(),q[i].id=i;<br />
	sort(q+1,q+m+1,cmp);<br />
}

void solve(){<br />
	int j=1;<br />
	for(int i=1;i&lt;=m;i++){<br />
		for(;j&lt;=q[i].r;j++)modify(pre[j],-1),modify(j,1);<br />
		ans[q[i].id]=query(q[i].r)-query(q[i].l-1);<br />
	}<br />
	for(int i=1;i&lt;=m;i++)printf(&quot;%d\n&quot;,ans[i]);<br />
}

int main(){<br />
	read_and_parse();<br />
	solve();<br />
	return 0;<br />
}<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7mrm1q.html">JestClient</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwvg538.html">MongoDB初学</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e014kq.html">MySQL中日期与时间类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j5yew8.html">【ASP&period;NET 进阶】根据IP地址返回对应位置信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zkdy29.html">vs2005无法启动</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvzzpoq.html">stitch image app &lpar;Qt&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vnrnj8.html">Spring MVC 3&period;0 返回JSON数据的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xr6vr9.html">Scoket简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn31oj8.html">apache2&period;2 虚拟主机配置详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okzwzl9.html">java学习之数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy11ynjq.html">Debug with Eclipse</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdppkzvq.html">Cocos2d-x3&period;0游戏实例《不要救我》三&mdash;&mdash;背景滚动周期</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj2yog8.html">mybatis--常见的错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zg6yg9.html">Cordova各个插件使用介绍系列（六）&mdash;&dollar;cordovaDevice获取设备的相关信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg3wld8.html">vxWorks下intel82567v3网卡驱动的更新</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgx6648.html">H（X&vert;Y）的推到过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jrde38.html">uiautomator2 使用Python测试 Android应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdnv6d9.html">Unix即IDE</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj3lxl9.html">Pycharm For Linux</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2zl3y9.html">Maven  通过maven对项目进行拆分、聚合（重点）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/95gywj6q.html">sudo 与输出重定向</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1ogxlq.html">SCP和Rsync远程拷贝的几个技巧</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyxgljq.html">getUserMedia API及HTML5 调用摄像头和麦克风</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o30wk8.html">Beta版会议总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rl1wj9.html">理解java的三大特性之继承</a>
			</li>
						<li><a href="https://www.batexi.com/a/960gg3n9.html">elastic-search-kibana-in-docker-dotnet-core-app</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o3ww18.html">OpenCV Code&colon; Operations on Mat element</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll726xq.html">数组操作方法（包括es5）</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wkrywq.html">【历史】- Windows NT 之父 - David Cutler</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyxn439.html">理解 Delphi 的类&lpar;十&rpar; - 深入方法&lbrack;18&rsqb; - 在接口区声明的方法都相当于提前声明了</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
